<% @Page Language="VB" Explicit="True" %>

<script runat=server>
    Public hs As Scheduler.hsapplication

	' this page calls itself; if postfield is set then this page saves its own data 
    Public savemode As Boolean

    Dim numlines As Integer
    Dim progAry(25, 10) As String '25 lines, 10 params per line with setback
    Dim tempstr As String
    


    Function readCycleParameters() As Integer
        'this vbscript function is executed on the server
        'we cant read or write files to the server using vbscript
        'we don't want to use hs global variables because they are destroyed at reboot
        'we will use the hs.getINISection and hs.saveINISetting functions get and save the cycles
        'use the following  command to save the cycles:  (creates section "stored cycles" and key "ercycles"
        '       hs.SaveINISetting "stored cycles","ercycles",erVar,"EtherRain.ini"
        Dim i, j, k, m, n As Integer
        ' Dim wstr, kstr As String
        Dim erVar As String
        Dim cycles() As String   'this is a one dimensional array
        Dim params() As String   'this is a one dimensional array
        'Dim estr As String
        Dim items() As String
        Dim cItems As Integer
        Dim section As String
        
        erVar = ""
        section = hs.GetINISection("stored cycles", "EtherRain.ini")
        If Len(section) > 0 Then
            items = Split(section, Chr(0))
            For i = 0 To UBound(items)
                'Response.Write "<p><b>Item " & items(i) & "</b></p><hr>"
                j = InStr(items(i), "ercycles=")
                If j > 0 Then
                    erVar = Mid(items(i), j + 9)
                    Exit For
                End If
            Next
        End If
        'Response.Write "<p><b>ER Var length is : " & len(erVar) & "bytes)</b></p><hr>"
        'Response.Write "<p><b>ER Var is : " & erVar & "</b></p><hr>"
        'now initialize the empty array
        For i = 0 To 24
            For j = 0 To 9
                progAry(i, j) = ""
            Next
        Next
        If Len(erVar) > 0 Then 'parse the storage variable here
            'the cycles are separated by "|" 
            'the values are separated by ";"
            'we need to utilize the split function twice to load progAry
            cycles = Split(erVar, "|")
            For i = 0 To UBound(cycles)
                params = Split(cycles(i), ";")
                cItems = 9
                If UBound(params) > 9 Then cItems = 9
                For j = 0 To cItems
                    progAry(i, j) = params(j)
                Next
            Next
            readCycleParameters = UBound(cycles) + 1
        Else
            readCycleParameters = 0
        End If
	
    End Function

    Sub saveCycleParameters(ctstr As String)
        'save the cycles here
		'the javascript function puts all of the form fields into a single string and sets the 
		'string = to storevar .  storevar is the only form input field.  It can be saved directly to HomeSeer 
        If Len(ctstr) > 0 Then
            'use the following  command to save the cycles:  (creates section "stored cycles" and key "ercycles"
            hs.SaveINISetting("stored cycles", "ercycles", ctstr, "EtherRain.ini")
        Else
            'instead of storing no data, lets just remove the key from the section
            'we'll put the controller data under another section "stored controllers"
            'because currently there is only one key, we could remove the whole section
            'lets just clear the section; if we put more in EtheRain.ini we'll put it in another section
            hs.ClearINISection("stored cycles", "EtherRain.ini")
	
        End If
    End Sub

' ***End Function Declaration***
</script>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<HEAD>
  <title>EtherRain Cycle Builder for HS3</title>
<link rel="stylesheet" type="text/css" href="/style.css"/>

<script type="text/javascript">
 <!--
	var xmlhttp;
	var  irows = 25;
	var  icols = 9;

   function checkMakeVars ( form )
	 {
        var tstr = "";
		var i;
		var j;
		var k = 0;
		var wstr = "";
		var nstr = "";
		//first check that the zones contain only numbers
		for (i=1;i <= irows;i++) {
		   for (j=2;j <= icols;j++) {
		       tstr = "T" + i + j;
	 	       k = form[tstr].value;
   	           //alert( k );
			   if (isNaN(k) ){
			     form[tstr].focus();
   	             alert("Non-numeric Zone Time Found. Please ensure that all Zone times are numeric");
			     return false;
			  }
		   }
        }

       //now put all the data into one string
		  for (i=1;i <= irows;i++) {
		    tstr = "T" + i + 1;
	 	    nstr = form[tstr].value;
   	        //alert( nstr );
			if (nstr.length > 0) {
			   //bug fix 8-3-2011 <= irows!!
		       if (i > 1 && i <= irows) {
   	             wstr = wstr + "|";
			   }
		       for (j=1;j <= icols;j++) {
		          tstr = "T" + i + j;
	 	          k = form[tstr].value;
				  if (k.length == 0) {
				     k = 0;
				  }
   	              wstr = wstr + k;
   	              wstr = wstr + ";";
			   }
		       
			   tstr = "CKSB" + i;
	 	       
	 	       if ( form[tstr].checked ) {
			     wstr = wstr + "SB";
			   }else{
			     wstr = wstr + "NO";
			   }
		      
		    }
		  
			  
		  }
	      form.storevar.value = wstr;
		  //alert(wstr);
		  return true;
		  
		}

   function clearForm ( form )
	 {
        var tstr = "";
		var i;
		var j;
		var k = 0;
		var wstr = "";
		var nstr = "";
		
		k = confirm("This will clear all fields on the form.  Continue?");
		//alert(k);
		if (k) {
		   for (i=1;i <= irows;i++) {
		     for (j=1;j <= icols;j++) {
		       tstr = "T" + i + j;
	 	       document.cycleform[tstr].value = "";
 		     }
	       }
  		}

	   return
     }
	 
	//-->
</script> 

</head>


<%
    ' *** main script block  *****
    Dim i, j As Integer
    Dim rstr As String
    'this line must be on every page along with the original dim
    hs = Context.Items("Content")

    savemode = False
    rstr = Request.Form("postcheck")
    If Len(rstr) > 0 Then
        savemode = True
        rstr = Request.Form("storevar")
        'Response.Write("saving: " & rstr & "<br />")
        saveCycleParameters(rstr)
    Else
        savemode = False
    End If
    readCycleParameters()
%>

<body style= "margin-left: 4%; margin-right: 4%; background:white; 
			 color: black; 
			 font-size: 11px;
			 font-weight: normal;
			 font-family: verdana, arial, sans-serif;"
>

	  <div style="float:left; width:800px; height:26px;padding-top:3px;padding-left:2px; background-color: black;border-bottom:solid 2px grey;">
	   
	  <input style="width:120px;" type="button" class="linkrowbutton" value="HomeSeer Start" alt="Start" onClick="location.href='/start/start.aspx'" onmouseover="this.className='linkrowbuttonselected';" onmouseout="this.className='linkrowbutton';">
	  <input style="width:120px;" type="button" class="linkrowbutton" value="HomeSeer Home" alt="Home" onClick="location.href='/'" onmouseover="this.className='linkrowbuttonselected';" onmouseout="this.className='linkrowbutton';">
	  <input style="width:120px;" type="button" class="linkrowbutton" value="EtherRain Home" alt="EtherRain Home" onClick="location.href='er_home.aspx'" onmouseover="this.className='linkrowbuttonselected';" onmouseout="this.className='linkrowbutton';">
	  <input style="width:120px;" type="button" class="linkrowbutton" value="EtherRain Help" alt="EtherRain Help" onClick="location.href='er_help.aspx'" onmouseover="this.className='linkrowbuttonselected';" onmouseout="this.className='linkrowbutton';">
	  </div>



   <div style="float:left; width:800px; text-align: center;
			font-size: 11px; font-weight: normal;
	         text-align:center;   /* hack for ie5  */
			font-family: verdana, arial, sans-serif; ">
   
	
    <div style="float:left; width: 800px;height:60px; 
		        border: 1px solid forestgreen;
			    background-color: lightgreen;
				font:arial, sans-serif; ">
		 <div style="float:left; width: 80px;margin-top:6px;">
	         <img style= "float:left; padding-left:35px;" align="middle" alt="EtherRain Logo" src="ershieldlogo.png" />  
	     </div>
		 <div style= "float:left;width: 610px;padding-top:7px;">
              <p style="color:white;font-weight:600; font-size:24px;
			            margin-top:5px; margin-bottom:2px;padding-top:5px;text-align:center;">
		             EtherRain CycleBuilder
			  </p>
		 </div>
    </div>

    <div style="float:left; width:800px;height:1210px;margin-top:2px;border:1px solid silver;
			text-align:left; overflow: auto;">
        <div style="float:left; width:70px; height:510px; margin:0px; ">
        </div>
        <div style="float:left; width:660px; height:515px; margin:0px; ">

	  <% 
	    if savemode = false then
	          Response.Write("<p style=""padding-left:40px; padding-right:20px; margin-top:8px;margin-bottom:8px;text-align:justify;"">")
	          Response.Write("Cycle Builder lets you create and save up to 25 named irrigation cycles ")
	          Response.Write("which can then be conveniently referenced when defining HomeSeer events using the ""runNamedCycles"" function provided by ")
	          Response.Write("the EtherRain script.  By using descriptive names, you can define cycles to apply to ")
	          Response.Write("irrigation events based on seasonal or weather related conditions and can apply them ")
	          Response.Write("to any EtherRain controller on your network. ")
	          Response.Write("</p>")
	          Response.Write("<p style=""padding-left:40px; padding-right:20px; margin-top:8px;margin-bottom:8px;text-align:justify;"">")
	          Response.Write("You can assign a monthly setback profile to each cycle by checking the ""S/B"" box on the cycle line.  ")
	          Response.Write("See Set-Back setup for more information on how to develop a water-saving setback profile.")
	          Response.Write("</p>")
	          Response.Write("<p style=""padding-left:40px; padding-right:20px; margin-top:8px;text-align:justify;"">")
	          Response.Write("NOTE: a zone will only run if the controller that uses the cycle has named the zone.  If you expect 7 ")
	          Response.Write("zones to run, then your controller must have at least 7 named zones.")
	          Response.Write("</p>")
	          Response.Write("<p style=""padding-left:40px; padding-right:20px; margin-top:8px;text-align:justify;"">")
	          Response.Write("To create and save cycles, just create a cycle name and corresponding zone time values. ")
	          Response.Write("Then click save.")
	          Response.Write("</p>")
	    else
	          Response.Write("<p style=""padding-left:40px; padding-right:20px; font-size:14px; font-weight:bold; margin-top:15px;text-align:center;"">")
	          Response.Write("Your Cycle Data Has Been Saved")
	          Response.Write("</p>")
	          Response.Write("<p style=""padding-left:40px; padding-right:20px; margin-top:8px;text-align=justify;"">")
	          Response.Write("The cycle data displayed below has been saved. To make further changes simply ")
	          Response.Write("update the fields and click the Save button at the bottom of the Screen. ")
	          Response.Write("If editing is complete, click the EtherRain Home button above to continue. ")
	          Response.Write("</p>")
		end if
	  %>
      <form name="cycleform" action="er_cyclebuilder.aspx" method="post" onsubmit="return checkMakeVars(this);">
			<table style="text-align: center;font-family: Verdana, sans-serif, Arial;
	   			   font-weight: normal;
				  color: #404040;
				  width: 600px;
				  background-color: #fafafa;
				  border: 1px #d79900 solid;
				  border-collapse: collapse;
				  border-spacing: 0px;"


 				  cellspacing="0" cellpadding="7" align="center" border="0">
         		  <thead bgcolor=whitesmoke >
            <tr style= "background-color: #fff2ba;">
              <th style="font-size: 9px;font-weight: bold; border-right: 1px #d79900 solid;width:22px; text-align:center;" >Set</th>
               <th rowspan=2 style="font-size: 9px;font-weight: bold; border: 1px #d79900 solid;width:180px;" >Cycle Name</th>
             <th style="font-size: 9px;font-weight: bold;border-bottom: 1px #d79900 solid;" colspan=8>Zone On-Time in Minutes</th>
            </tr>
            <tr style= "background-color: #fff2ba;">
              <th style="font-size: 9px;font-weight: bold; border-right: 1px #d79900 solid;border-bottom: 1px #d79900 solid;width:22px;text-align:center;" >Back</th>
              <th style="font-size: 9px;font-weight: bold;border-bottom: 1px #d79900 solid;">1</th>
              <th style="font-size: 9px;font-weight: bold;border-bottom: 1px #d79900 solid;">2</th>
              <th style="font-size: 9px;font-weight: bold;border-bottom: 1px #d79900 solid;">3</th>
              <th style="font-size: 9px;font-weight: bold;border-bottom: 1px #d79900 solid;">4</th>
              <th style="font-size: 9px;font-weight: bold;border-bottom: 1px #d79900 solid;">5</th>
              <th style="font-size: 9px;font-weight: bold;border-bottom: 1px #d79900 solid;">6</th>
              <th style="font-size: 9px;font-weight: bold;border-bottom: 1px #d79900 solid;">7</th>
              <th style="font-size: 9px;font-weight: bold;border-bottom: 1px #d79900 solid;">8</th>
            </tr>
		  
		  </thead>
		  <tbody >
	<%
	      for i = 0 to 24
		    
		    j= 0	  
	        Response.Write("<tr style=""border-bottom: 1px dotted #d79900;text-align: left; font-family: Verdana; font-weight: 400;color: #404040;"">")
	        Response.Write(" <td style=""padding-left:5px;"">")
			if progAry(i,9) = "SB" then tempstr = "checked" else tempstr = ""
			  
	        Response.Write("<INPUT style=""font-size:11px;"" TYPE=""checkbox"" NAME=""CKSB" & Trim(i + 1) & """value=""1""" & tempstr & ">")
	        Response.Write("</td>")
	        Response.Write(" <td style=""padding-left:15px;"">")
	        Response.Write("<INPUT style=""font-size:12px;"" TYPE=""text"" NAME=""T" & Trim(i + 1) & Trim(j + 1) & _
	      """ value = """ & progAry(i, j) & """ maxlength=""24"" SIZE=""25"">")
	        Response.Write("</td>")
		    for j = 1 to 8
	            Response.Write("<td style=""text-align:center;font-size:12px;"">")
	            Response.Write("<INPUT style=""width:18px;font-size:12px;"" TYPE=""text"" NAME=""T" & Trim(i + 1) & Trim(j + 1) & _
  """ value = """ & progAry(i, j) & """ maxlength=""2"" SIZE=""3"">")
	            Response.Write("</td>")
			next
	        Response.Write("</tr>")
		  next  
	 %>
          </tbody>
        </table>
		<INPUT TYPE="hidden" NAME = "postcheck" VALUE="1" />
		<INPUT TYPE="hidden" NAME = "storevar" VALUE="" />
        <p style="font-size:14px;margin-top:10px; margin-bottom:10px;padding-left: 25px; text-align:center; font:arial; ">
           <input type="submit" value="Save Cycles" /> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
           <input style="font-size:10px;" type="button" value=" Clear " onclick="clearForm(this);"/>
		</p>
  </form>
      </div>
    </div>
     <p style="padding-left:10px;  font-size:10px; text-align:left; ">
        &copy; 2011-2017 QuickSmart Development www.quicksmart.com
      </p>
   </div>

 </body>
</html>
